M = 100;
area = [-12, 80, 0, 10];
%area = [-12, 62, 0, 12.7];

% vars = zeros(1,11); center = vars; err = vars;
% nums = zeros(11,M); cens = nums;
% 
% for i = 1:5, 
%     eval(['load llr_' int2str(i) '.5.dat']);
%     j = i+i;
%     eval(['vars(j) = var(llr_' int2str(i) ');']);
%     eval(['center(j) = mean(llr_' int2str(i) ');']);
%     eval(['err(j) = mean(llr_' int2str(i) '<0);']);
%     eval(['[nums(j,:), cens(j,:)] = hist(llr_' int2str(i) ', M);']);
%     % the width of cen is (cen(2) - cen(1))
%     % from sum width*value = 1 we can get value = hits/N/width
%     N = sum(nums(j,:));  % N == length(llr_1)
%     nums(j,:) = nums(j,:) / N / (cens(j,2) - cens(j,1)) * 100;
% end
% 
% for i = 1:6, 
%     eval(['load llr_' int2str(i) '.0.dat']);
%     j = i+i-1;
%     eval(['vars(j) = var(llr_' int2str(i) ');']);
%     eval(['center(j) = mean(llr_' int2str(i) ');']);
%     eval(['err(j) = mean(llr_' int2str(i) '<0);']);
%     eval(['[nums(j,:), cens(j,:)] = hist(llr_' int2str(i) ', M);']);
%     % the width of cen is (cen(2) - cen(1))
%     % from sum width*value = 1 we can get value = hits/N/width
%     N = sum(nums(j,:));  % N == length(llr_1)
%     nums(j,:) = nums(j,:) / N / (cens(j,2) - cens(j,1)) * 100;
% end
% 
% save llrdata vars center err nums cens
load llrdata

ber = 0.5 * erfc(center ./ sqrt(2 * vars));
ber * 1024

figure; semilogy(1:0.5:6, err, 'bo-');
hold on; semilogy(1:0.5:6, ber, 'r');
grid on;
legend('Actual BER', 'BER from the Gaussian dist.');
xlabel('E_b/N_0');
ylabel('BER (bit error rate)');

%% var v.s. mean
figure; plot(center, vars, 'o-'); hold on; %plot(sqrt(1:6), center);
p = polyfit(center, vars, 1);
plot([6,44], p(1) .* [6,44]+p(2), 'r--');
% plot([5,35], p(1) .* [5,35]+p(2), 'r--');
legend('Real LLR', [num2str(p(1)) 'x + ' num2str(p(2))]);
xlabel('mean(LLR)');
ylabel('var(LLR)');

%% dist.
figure;
for i = 1 : 6,
    subplot(2, 3, i);
    j = i+i-1;
    plot(cens(j,:), nums(j,:));
    title(['E_b/N_0 = ' int2str(i) 'dB']);
    ylabel('Percentage (%)');
    xlabel('LLR');
    axis(area);
    
    % plot the gaussian
    x = area(1):area(2);
    y = 1 / sqrt(2 * pi * vars(j)) * exp(-(x - center(j)).^2 / 2 / vars(j));
    hold on;
    plot(x, y * 100, 'r--');
end
