%% var v.s. mean
figure; hold on;

load llr5k_sqr
plot(center, vars, 'bo');
p = polyfit(center, vars, 1);
plot([6,42], p(1) .* [6,42]+p(2), 'b--');
s1 = ['v = ' num2str(p(1)) 'm + ' num2str(p(2))];


load llr5k_sqr_rc
plot(center, vars, 'r+');
p = polyfit(center, vars, 1);
l = plot([6,42], p(1) .* [6,42]+p(2), 'r:');
set(l, 'linewidth', 2);
s2 = ['v = ' num2str(p(1)) 'm + ' num2str(p(2))];

load llr5k_sqr_rc_sig
plot(center, vars, 'k^');
p = polyfit(center, vars, 1);
plot([5,33], p(1) .* [5,33]+p(2), 'k-');
s3 = ['v = ' num2str(p(1)) 'm + ' num2str(p(2))];

legend('LLR', s1, 'LLR (random codeword)', s2, 'LLR (guess sigma)', s3);
xlabel('mean(LLR)');
ylabel('var(LLR)');

grid on;